CSIT-1032: MRR Tests: IPv6, x710
[csit.git] / bootstrap-verify-perf.sh
1 #!/bin/bash
2 # Copyright (c) 2018 Cisco and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -x
16
17 # Space separated list of available testbeds, described by topology files
18 TOPOLOGIES="topologies/available/lf_testbed1.yaml \
19             topologies/available/lf_testbed2.yaml \
20             topologies/available/lf_testbed3.yaml"
21
22 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
23
24 # Reservation dir
25 RESERVATION_DIR="/tmp/reservation_dir"
26 INSTALLATION_DIR="/tmp/install_dir"
27
28 PYBOT_ARGS="-W 150 -L TRACE"
29
30 JOB_ARCHIVE_ARTIFACTS=(log.html output.xml report.html)
31 LOG_ARCHIVE_ARTIFACTS=(log.html output.xml report.html)
32 JOB_ARCHIVE_DIR="archive"
33 LOG_ARCHIVE_DIR="$WORKSPACE/archives"
34 mkdir -p ${JOB_ARCHIVE_DIR}
35 mkdir -p ${LOG_ARCHIVE_DIR}
36
37 # If we run this script from CSIT jobs we want to use stable vpp version
38 if [[ ${JOB_NAME} == csit-* ]] ;
39 then
40     mkdir vpp_download
41     cd vpp_download
42
43     if [[ ${TEST_TAG} == *DAILY ]] || \
44        [[ ${TEST_TAG} == *WEEKLY ]];
45     then
46         # Download the latest VPP build .deb install packages
47         echo Downloading VPP packages...
48         bash ${SCRIPT_DIR}/resources/tools/scripts/download_install_vpp_pkgs.sh --skip-install
49
50         VPP_DEBS="$( readlink -f *.deb | tr '\n' ' ' )"
51         # Take vpp package and get the vpp version
52         VPP_STABLE_VER="$( expr match $(ls *.deb | head -n 1) 'vpp-\(.*\)-deb.deb' )"
53     else
54         DPDK_STABLE_VER=$(cat ${SCRIPT_DIR}/DPDK_STABLE_VER)_amd64
55         VPP_REPO_URL=$(cat ${SCRIPT_DIR}/VPP_REPO_URL_UBUNTU)
56         VPP_STABLE_VER=$(cat ${SCRIPT_DIR}/VPP_STABLE_VER_UBUNTU)
57         VPP_CLASSIFIER="-deb"
58         # Download vpp build from nexus and set VPP_DEBS variable
59         wget -q "${VPP_REPO_URL}/vpp/${VPP_STABLE_VER}/vpp-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
60         wget -q "${VPP_REPO_URL}/vpp-dbg/${VPP_STABLE_VER}/vpp-dbg-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
61         wget -q "${VPP_REPO_URL}/vpp-dev/${VPP_STABLE_VER}/vpp-dev-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
62         wget -q "${VPP_REPO_URL}/vpp-dpdk-dkms/${DPDK_STABLE_VER}/vpp-dpdk-dkms-${DPDK_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
63         wget -q "${VPP_REPO_URL}/vpp-lib/${VPP_STABLE_VER}/vpp-lib-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
64         wget -q "${VPP_REPO_URL}/vpp-plugins/${VPP_STABLE_VER}/vpp-plugins-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
65         VPP_DEBS="$( readlink -f *.deb | tr '\n' ' ' )"
66     fi
67
68     cd ..
69
70 # If we run this script from vpp project we want to use local build
71 elif [[ ${JOB_NAME} == vpp-* ]] ;
72 then
73     # Use local packages provided as argument list
74     # Jenkins VPP deb paths (convert to full path)
75     VPP_DEBS="$( readlink -f $@ | tr '\n' ' ' )"
76     # Take vpp package and get the vpp version
77     VPP_STABLE_VER="$( expr match $1 'vpp-\(.*\)-deb.deb' )"
78 else
79     echo "Unable to identify job type based on JOB_NAME variable: ${JOB_NAME}"
80     exit 1
81 fi
82
83 WORKING_TOPOLOGY=""
84 export PYTHONPATH=${SCRIPT_DIR}
85
86 sudo apt-get -y update
87 sudo apt-get -y install libpython2.7-dev python-virtualenv
88
89 virtualenv --system-site-packages env
90 . env/bin/activate
91
92 echo pip install
93 pip install -r requirements.txt
94
95 # We iterate over available topologies and wait until we reserve topology
96 while :; do
97     for TOPOLOGY in ${TOPOLOGIES};
98     do
99         python ${SCRIPT_DIR}/resources/tools/scripts/topo_reservation.py -t ${TOPOLOGY}
100         if [ $? -eq 0 ]; then
101             WORKING_TOPOLOGY=${TOPOLOGY}
102             echo "Reserved: ${WORKING_TOPOLOGY}"
103             break
104         fi
105     done
106
107     if [ ! -z "${WORKING_TOPOLOGY}" ]; then
108         # Exit the infinite while loop if we made a reservation
109         break
110     fi
111
112     # Wait ~3minutes before next try
113     SLEEP_TIME=$[ ( $RANDOM % 20 ) + 180 ]s
114     echo "Sleeping ${SLEEP_TIME}"
115     sleep ${SLEEP_TIME}
116 done
117
118 function cancel_all {
119     python ${SCRIPT_DIR}/resources/tools/scripts/topo_installation.py -c -d ${INSTALLATION_DIR} -t $1
120     python ${SCRIPT_DIR}/resources/tools/scripts/topo_reservation.py -c -t $1
121 }
122
123 # On script exit we cancel the reservation and installation and delete all vpp
124 # packages
125 trap "cancel_all ${WORKING_TOPOLOGY}" EXIT
126
127 python ${SCRIPT_DIR}/resources/tools/scripts/topo_installation.py -t ${WORKING_TOPOLOGY} \
128                                                        -d ${INSTALLATION_DIR} \
129                                                        -p ${VPP_DEBS}
130 if [ $? -eq 0 ]; then
131     echo "VPP Installed on hosts from: ${WORKING_TOPOLOGY}"
132 else
133     echo "Failed to copy vpp deb files to DUTs"
134     exit 1
135 fi
136
137 case "$TEST_TAG" in
138     # run specific performance tests based on jenkins job type variable
139     PERFTEST_DAILY )
140         pybot ${PYBOT_ARGS} \
141               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
142               -s "tests.vpp.perf" \
143               --include ndrdiscANDnic_intel-x520-da2AND1t1cORndrdiscANDnic_intel-x520-da2AND2t2c \
144               --include ndrdiscAND1t1cANDipsecORndrdiscAND2t2cANDipsec \
145               tests/
146         RETURN_STATUS=$(echo $?)
147         ;;
148     PERFTEST_SEMI_WEEKLY )
149         pybot ${PYBOT_ARGS} \
150               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
151               -s "tests.vpp.perf" \
152               --include ndrdiscANDnic_intel-x710AND1t1cORndrdiscANDnic_intel-x710AND2t2cORndrdiscANDnic_intel-xl710AND1t1cORndrdiscANDnic_intel-xl710AND2t2c \
153               tests/
154         RETURN_STATUS=$(echo $?)
155         ;;
156     PERFTEST_MRR_DAILY )
157         pybot ${PYBOT_ARGS} \
158               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
159               -s "tests.vpp.perf" \
160               --include mrrAND64bAND1t1c \
161               --include mrrAND64bAND2t2c \
162               --include mrrAND64bAND4t4c \
163               --include mrrAND78bAND1t1c \
164               --include mrrAND78bAND2t2c \
165               --include mrrAND78bAND4t4c \
166               --include mrrANDimixAND1t1cANDvhost \
167               --include mrrANDimixAND2t2cANDvhost \
168               --include mrrANDimixAND4t4cANDvhost \
169               --include mrrANDimixAND1t1cANDmemif \
170               --include mrrANDimixAND2t2cANDmemif \
171               --include mrrANDimixAND4t4cANDmemif \
172               tests/
173         RETURN_STATUS=$(echo $?)
174         ;;
175     VERIFY-PERF-NDRDISC )
176         pybot ${PYBOT_ARGS} \
177               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
178               -s "tests.vpp.perf" \
179               --include ndrdiscAND1t1cORndrdiscAND2t2c \
180               tests/
181         RETURN_STATUS=$(echo $?)
182         ;;
183     VERIFY-PERF-PDRDISC )
184         pybot ${PYBOT_ARGS} \
185               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
186               -s "tests.vpp.perf" \
187               --include pdrdiscAND1t1cORpdrdiscAND2t2c \
188               tests/
189         RETURN_STATUS=$(echo $?)
190         ;;
191     VERIFY-PERF-MRR )
192         pybot ${PYBOT_ARGS} \
193               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
194               -s "tests.vpp.perf" \
195               --include mrrAND1t1cORmrrAND2t2c \
196               tests/
197         RETURN_STATUS=$(echo $?)
198         ;;
199     VERIFY-PERF-IP4 )
200         pybot ${PYBOT_ARGS} \
201               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
202               -s "tests.vpp.perf" \
203               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDip4baseORndrdiscANDnic_intel-x520-da2AND1t1cANDip4fwdANDfib_2m \
204               tests/
205         RETURN_STATUS=$(echo $?)
206         ;;
207     VERIFY-PERF-IP6 )
208         pybot ${PYBOT_ARGS} \
209               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
210               -s "tests.vpp.perf" \
211               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDip6baseORndrdiscANDnic_intel-x520-da2AND1t1cANDip6fwdANDfib_2m \
212               tests/
213         RETURN_STATUS=$(echo $?)
214         ;;
215     VERIFY-PERF-L2 )
216         pybot ${PYBOT_ARGS} \
217               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
218               -s "tests.vpp.perf" \
219               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDl2xcbaseORndrdiscANDnic_intel-x520-da2AND1t1cANDl2bdbase \
220               tests/
221         RETURN_STATUS=$(echo $?)
222         ;;
223     VERIFY-PERF-LISP )
224         pybot ${PYBOT_ARGS} \
225               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
226               -s "tests.vpp.perf" \
227               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDlisp \
228               tests/
229         RETURN_STATUS=$(echo $?)
230         ;;
231     VERIFY-PERF-VXLAN )
232         pybot ${PYBOT_ARGS} \
233               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
234               -s "tests.vpp.perf" \
235               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDvxlan \
236               tests/
237         RETURN_STATUS=$(echo $?)
238         ;;
239     VERIFY-PERF-VHOST )
240         pybot ${PYBOT_ARGS} \
241               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
242               -s "tests.vpp.perf" \
243               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDvhost \
244               tests/
245         RETURN_STATUS=$(echo $?)
246         ;;
247     VERIFY-PERF-MEMIF )
248         pybot ${PYBOT_ARGS} \
249               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
250               -s "tests.vpp.perf" \
251               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDmemif \
252               tests/
253         RETURN_STATUS=$(echo $?)
254         ;;
255     VERIFY-PERF-IPSECHW )
256         pybot ${PYBOT_ARGS} \
257               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
258               -s "tests.vpp.perf.crypto" \
259               --include ndrdiscANDnic_intel-xl710AND1t1cANDipsechw \
260               --include ndrdiscANDnic_intel-xl710AND2t2cANDipsechw \
261               --include mrrANDnic_intel-xl710AND1t1cANDipsechw \
262               --include mrrANDnic_intel-xl710AND2t2cANDipsechw \
263               tests/
264         RETURN_STATUS=$(echo $?)
265         ;;
266     VPP-VERIFY-PERF-IP4 )
267         pybot ${PYBOT_ARGS} \
268               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
269               -s "tests.vpp.perf" \
270               --include mrrANDnic_intel-x520-da2AND1t1cANDip4baseORmrrANDnic_intel-x520-da2AND1t1cANDip4fwdANDfib_2m \
271               tests/
272         RETURN_STATUS=$(echo $?)
273         ;;
274     VPP-VERIFY-PERF-IP6 )
275         pybot ${PYBOT_ARGS} \
276               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
277               -s "tests.vpp.perf" \
278               --include mrrANDnic_intel-x520-da2AND1t1cANDip6baseORmrrANDnic_intel-x520-da2AND1t1cANDip6fwdANDfib_2m \
279               tests/
280         RETURN_STATUS=$(echo $?)
281         ;;
282     VPP-VERIFY-PERF-L2 )
283         pybot ${PYBOT_ARGS} \
284               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
285               -s "tests.vpp.perf" \
286               --include mrrANDnic_intel-x520-da2AND1t1cANDl2xcbaseORmrrANDnic_intel-x520-da2AND1t1cANDl2bdbase \
287               tests/
288         RETURN_STATUS=$(echo $?)
289         ;;
290     VPP-VERIFY-PERF-LISP )
291         pybot ${PYBOT_ARGS} \
292               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
293               -s "tests.vpp.perf" \
294               --include pdrchkANDnic_intel-x520-da2AND1t1cANDlisp \
295               tests/
296         RETURN_STATUS=$(echo $?)
297         ;;
298     VPP-VERIFY-PERF-VXLAN )
299         pybot ${PYBOT_ARGS} \
300               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
301               -s "tests.vpp.perf" \
302               --include pdrchkANDnic_intel-x520-da2AND1t1cANDvxlan \
303               tests/
304         RETURN_STATUS=$(echo $?)
305         ;;
306     VPP-VERIFY-PERF-VHOST )
307         pybot ${PYBOT_ARGS} \
308               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
309               -s "tests.vpp.perf" \
310               --include pdrdiscANDnic_intel-x520-da2AND1t1cANDvhost \
311               tests/
312         RETURN_STATUS=$(echo $?)
313         ;;
314     VPP-VERIFY-PERF-MEMIF )
315         pybot ${PYBOT_ARGS} \
316               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
317               -s "tests.vpp.perf" \
318               --include pdrdiscANDnic_intel-x520-da2AND1t1cANDmemif \
319               --include pdrdiscANDnic_intel-x520-da2AND2t2cANDmemif \
320               --include mrrANDnic_intel-x520-da2AND1t1cANDmemif \
321               --include mrrANDnic_intel-x520-da2AND2t2cANDmemif \
322               tests/
323         RETURN_STATUS=$(echo $?)
324         ;;
325     VPP-VERIFY-PERF-ACL )
326         pybot ${PYBOT_ARGS} \
327               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
328               -s "tests.vpp.perf" \
329               --include pdrdiscANDnic_intel-x520-da2AND1t1cANDacl \
330               --include pdrdiscANDnic_intel-x520-da2AND2t2cANDacl \
331               tests/
332         RETURN_STATUS=$(echo $?)
333         ;;
334     VPP-VERIFY-PERF-IPSECHW )
335         pybot ${PYBOT_ARGS} \
336               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
337               -s "tests.vpp.perf.crypto" \
338               --include pdrdiscANDnic_intel-xl710AND1t1cANDipsechw \
339               --include pdrdiscANDnic_intel-xl710AND2t2cANDipsechw \
340               --include mrrANDnic_intel-xl710AND1t1cANDipsechw \
341               --include mrrANDnic_intel-xl710AND2t2cANDipsechw \
342               tests/
343         RETURN_STATUS=$(echo $?)
344         ;;
345     * )
346         # run full performance test suite and exit on fail
347         pybot ${PYBOT_ARGS} \
348               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
349               -s "tests.vpp.perf" \
350               tests/
351         RETURN_STATUS=$(echo $?)
352 esac
353
354 # Archive JOB artifacts in jenkins
355 for i in ${JOB_ARCHIVE_ARTIFACTS[@]}; do
356     cp $( readlink -f ${i} | tr '\n' ' ' ) ${JOB_ARCHIVE_DIR}/
357 done
358 # Archive JOB artifacts to logs.fd.io
359 for i in ${LOG_ARCHIVE_ARTIFACTS[@]}; do
360     cp $( readlink -f ${i} | tr '\n' ' ' ) ${LOG_ARCHIVE_DIR}/
361 done
362
363 exit ${RETURN_STATUS}